#	Makefile.m4	1.7	89/02/19
#
# Copyright (c) 1988 by Sam Leffler.
# All rights reserved.
#
# This file is provided for unrestricted use provided that this
# legend is included on all tape media and as a part of the
# software program in whole or part.  Users may copy, modify or
# distribute this file at will.
#
ifelse(version, profiled,
    `define(`LIBTIFF', libtiff_p)', `define(`LIBTIFF', libtiff)')dnl
include(CONF/target.m4)dnl
STAMP(`#', `Tag Image File Format Library', target, config, version,
    ifdef(`targetopts', targetopts) ifdef(`floatopts', floatopts))
VPATH=	.:..
DESTDIR=
#
AR=	ARCHIVER
RANLIB=	RANLIBER
sinclude(conf/target.m4)dnl
include(CONF/config.m4)dnl
sinclude(conf/config.m4)dnl
undefine(`include')dnl
IPATH=	-I.. ifdef(`MACHINCS', MACHINCS)
#
# BYTECOUNTHACK	add workaround for TIFF files w/o StripByteCounts tag
# EAHACK	add workaround for TIFF files written by Electronic Arts
# PICIO_SUPPORT	support Pixar picio RLE algorithm
#
COPTS=	-DEAHACK -DBYTECOUNTHACK
CFLAGS=	VERSOPTS MACHOPTS ${COPTS} ${IPATH}
#
INCS=	tiff.h tiffio.h 	# extra blank for make VPATH bug
SRCS=	tiff_ccittfax.c tiff_ccittrle.c tiff_close.c tiff_compress.c \
	tiff_dir.c tiff_dumpmode.c tiff_error.c tiff_flush.c tiff_lzw.c \
	tiff_open.c tiff_packbits.c tiff_picio.c tiff_print.c tiff_read.c \
	tiff_swab.c tiff_thunder.c tiff_warning.c tiff_write.c
OBJS=	tiff_ccittfax.OSUF tiff_ccittrle.OSUF tiff_close.OSUF \
	tiff_compress.OSUF tiff_dir.OSUF tiff_dumpmode.OSUF tiff_error.OSUF \
	tiff_flush.OSUF tiff_lzw.OSUF tiff_open.OSUF tiff_packbits.OSUF \
	tiff_picio.OSUF tiff_print.OSUF tiff_read.OSUF tiff_swab.OSUF \
	tiff_thunder.OSUF tiff_warning.OSUF tiff_write.OSUF
ALL=	LIBTIFF.ARSUF

SUFFIXDEPEND(`#')

all:	 ${ALL}

${ALL}:	${OBJS}
	${AR} rc LIBTIFF.ARSUF $?
	${RANLIB} LIBTIFF.ARSUF

install: all installh
	-for i in ${ALL}; do \
		${INSTALL} -c -m 644 $$i ${DESTDIR}/${REYES}/lib/$$i; \
		${RANLIB} ${DESTDIR}/${REYES}/lib/$$i; \
	done

changequote([,])dnl
installh: ${INCS}
	-for i in ${INCS}; do \
	    h=`basename $$i`; \
	    cmp -s $$i ${DESTDIR}/${REYES}/include/$$h || \
	        ${INSTALL} -c -m 444 $$i ${DESTDIR}/${REYES}/include/$$h; \
	done
changequote
clean:
	rm -f ${ALL} ${OBJS} core a.out
 
tags:	${SRCS}
	${CTAGS} ${SRCS}

depend: ${SRCS}
	MAKEDEPEND(`#')

