#ifndef lint
static char sccsid[] = "@(#)tiff2ps.c	1.2 2/19/89";
#endif

/*
 * Copyright (c) 1988 by Sam Leffler.
 * All rights reserved.
 *
 * This file is provided for unrestricted use provided that this
 * legend is included on all tape media and as a part of the
 * software program in whole or part.  Users may copy, modify or
 * distribute this file at will.
 */

#include <stdio.h>
#include <ctype.h>
#include "tiffio.h"

#define	howmany(x, y)	(((x)+((y)-1))/(y))

main(argc, argv)
	char *argv[];
{
	register TIFF *tif;
	TIFFDirectory *td;
	u_char *scanbuf, *pp;
	int bitspersample, scanline, samplesperbyte;
	register int cc, bytesperline, stride;
	int w, h, i, dirnum = -9999;
	unsigned width = -1, height = -1;

	for (argc--, argv++; argc > 0 && argv[0][0] == '-'; argc--, argv++) {
		if (isdigit(argv[0][1])) {
			dirnum = atoi(&argv[0][1]);
			continue;
		}
		if (strcmp(argv[0], "-w") == 0) {
			argc--, argv++;
			width = atoi(argv[0]);
			continue;
		}
		if (strcmp(argv[0], "-h") == 0) {
			argc--, argv++;
			height = atoi(argv[0]);
			continue;
		}
	}
	if (argc <= 0) {
		fprintf(stderr,
		   "usage: tiff2ps [-#] [-w width] [-h height] TIFF-file\n");
		exit(-1);
	}
	tif = TIFFOpen(argv[0], "r");
	if (tif == NULL)
		exit(-1);
	do {
		if (dirnum != -9999) {
			dirnum--;
			if (dirnum > 0)
				continue;
			if (dirnum < 0)
				break;
		}
		td = tif->tif_dir;
		bitspersample = td->td_bitspersample;
		if (td->td_planarconfig == PLANARCONFIG_CONTIG)
			bitspersample *= td->td_samplesperpixel;
		scanline = howmany(bitspersample * td->td_imagewidth, 8);
		scanbuf = (u_char *)malloc(scanline);
		if (scanbuf == NULL) {
			printf("No space for scanline buffer\n");
			continue;
		}
		w = (width > td->td_imagewidth ? td->td_imagewidth : width);
		h = (height > td->td_imagelength ? td->td_imagelength : height);
		printf("%d %d %d [%d 0 0 -%d 0 %d] {<\n",
		     w, h, td->td_bitspersample, w, h, h);
		samplesperbyte =
		    bitspersample == 1 ? 8 : bitspersample == 4 ? 2 : 1;
		w /= samplesperbyte;
		stride = (td->td_planarconfig == PLANARCONFIG_CONTIG &&
		    td->td_samplesperpixel > 1 ? td->td_samplesperpixel-1 : 0);
		while (h-- > 0 && TIFFReadScanline(tif, scanbuf) > 0) {
			pp = scanbuf;
			for (cc = 0; cc < scanline && cc < w; cc++) {
				printf(" %02x",
				  td->td_photometric == PHOTOMETRIC_MINISWHITE ?
				    ~(*pp++) & 0xff : *pp++);
				if (((cc+1) % 24) == 0)
					putchar('\n');
				pp += stride;
			}
			putchar('\n');
		}
		printf("\n>} image\n");
		free((char *)scanbuf);
	} while (TIFFReadDirectory(tif));
	if (tif)
		TIFFClose(tif);
}
